VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ID3tag"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Author: Alvaro Redondo <merlin@sevillaonline.com>
' http://www.sevillaonline.com/ActiveX
' Version: 1.0
' Last modification date: 30.09.2000
' Description: ID3 tags are used to store information in multimedia files, commonly MP3 files.
'               This class manages version 1.0 and 1.1 ID3 tags.

Option Explicit

Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000

Private Const OPEN_EXISTING = 3

Private Const INVALID_HANDLE_VALUE = -1

Private Const FILE_BEGIN = 0

Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" _
    (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, _
    ByVal dwShareMode As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, _
    ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, _
    ByVal hTemplateFile As Long) As Long

Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, _
    ByVal lDistanceToMove As Long, lpDistanceToMoveHigh As Long, _
    ByVal dwMoveMethod As Long) As Long

Private Declare Function SetEndOfFile Lib "kernel32" _
    (ByVal hFile As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" _
    (ByVal hObject As Long) As Long

Enum enGenres
    [Blues] = 0
    [Classic Rock] = 1
    [Country] = 2
    [Dance] = 3
    [Disco] = 4
    [Funk] = 5
    [Grunge] = 6
    [Hip-Hop] = 7
    [Jazz] = 8
    [Metal] = 9
    [New Age] = 10
    [Oldies] = 11
    [Other] = 12
    [Pop] = 13
    [R&B] = 14
    [Rap] = 15
    [Reggae] = 16
    [Rock] = 17
    [Techno] = 18
    [Industrial] = 19
    [Alternative] = 20
    [Ska] = 21
    [Death Metal] = 22
    [Pranks] = 23
    [Soundtrack] = 24
    [Euro-Techno] = 25
    [Ambient] = 26
    [Trip-Hop] = 27
    [Vocal] = 28
    [Jazz+Funk] = 29
    [Fusion] = 30
    [Trance] = 31
    [Classical] = 32
    [Instrumental] = 33
    [Acid] = 34
    [House] = 35
    [Game] = 36
    [Sound Clip] = 37
    [Gospel] = 38
    [Noise] = 39
    [AlternRock] = 40
    [Bass] = 41
    [Soul] = 42
    [Punk] = 43
    [Space] = 44
    [Meditative] = 45
    [Instrumental Pop] = 46
    [Instrumental Rock] = 47
    [Ethnic] = 48
    [Gothic] = 49
    [Darkwave] = 50
    [Techno-Industrial] = 51
    [Electronic] = 52
    [Pop-Folk] = 53
    [Eurodance] = 54
    [Dream] = 55
    [Southern Rock] = 56
    [Comedy] = 57
    [Cult] = 58
    [Gangsta] = 59
    [Top 40] = 60
    [Christian Rap] = 61
    [Pop/Funk] = 62
    [Jungle] = 63
    [Native American] = 64
    [Cabaret] = 65
    [New Wave] = 66
    [Psychadelic] = 67
    [Rave] = 68
    [Showtunes] = 69
    [Trailer] = 70
    [Lo-Fi] = 71
    [Tribal] = 72
    [Acid Punk] = 73
    [Acid Jazz] = 74
    [Polka] = 75
    [Retro] = 76
    [Musical] = 77
    [Rock & Roll] = 78
    [Hard Rock] = 79
    [Folk] = 80
    [Folk-Rock] = 81
    [National Folk] = 82
    [Swing] = 83
    [Fast Fusion] = 84
    [Bebob] = 85
    [Latin] = 86
    [Revival] = 87
    [Celtic] = 88
    [Bluegrass] = 89
    [Avantgarde] = 90
    [Gothic Rock] = 91
    [Progressive Rock] = 92
    [Psychedelic Rock] = 93
    [Symphonic Rock] = 94
    [Slow Rock] = 95
    [Big Band] = 96
    [Chorus] = 97
    [Easy Listening] = 98
    [Acoustic] = 99
    [Humour] = 100
    [Speech] = 101
    [Chanson] = 102
    [Opera] = 103
    [Chamber Music] = 104
    [Sonata] = 105
    [Symphony] = 106
    [Booty Bass] = 107
    [Primus] = 108
    [Porn Groove] = 109
    [Satire] = 110
    [Slow Jam] = 111
    [Club] = 112
    [Tango] = 113
    [Samba] = 114
    [Folklore] = 115
    [Ballad] = 116
    [Power Ballad] = 117
    [Rhythmic Soul] = 118
    [Freestyle] = 119
    [Duet] = 120
    [Punk Rock] = 121
    [Drum Solo] = 122
    [A capella] = 123
    [Euro-House] = 124
    [Dance Hall] = 125
End Enum

Private Type tipoTag
    Tag As String * 3
    Name As String * 30
    Artist As String * 30
    Album As String * 30
    Year As String * 4
    Comment As String * 30
    Genre As String * 1
End Type

Private m_sName As String, m_sAlbum As String, m_sArtist As String, _
    m_iYear As Integer, m_iGenre As Integer, m_sComment As String, _
    m_iSongNumber As Integer

Private m_sPath As String, m_bFileExists As Boolean, m_bReadOnly As Boolean, _
    m_bHasID3tag As Boolean

Property Get Album() As String
Attribute Album.VB_Description = "Sets / returns album name."
    Album = m_sAlbum
End Property

Property Let Album(sAlbum As String)
    m_sAlbum = IIf(Len(Trim(sAlbum)) > 30, Left(Trim(sAlbum), 30), Trim(sAlbum))
End Property

Property Get Artist() As String
Attribute Artist.VB_Description = "Sets / returns artist name."
    Artist = m_sArtist
End Property

Property Let Artist(sArtist As String)
    m_sArtist = IIf(Len(Trim(sArtist)) > 30, Left(Trim(sArtist), 30), Trim(sArtist))
End Property

Property Get Comment() As String
Attribute Comment.VB_Description = "Sets / returns comment field."
    Comment = m_sComment
End Property

Property Let Comment(sComment As String)
    m_sComment = IIf(Len(Trim(sComment)) > 30, Left(Trim(sComment), 30), Trim(sComment))
End Property

Property Get FileExists() As Boolean
Attribute FileExists.VB_Description = "Returns True if file exists."
    FileExists = m_bFileExists
End Property

Property Get FileName() As String
Attribute FileName.VB_Description = "Sets / returns path to the file we want to work with."
    FileName = m_sPath
End Property

Property Let FileName(ByVal sPath As String)
    Dim FF As Integer
    sPath = Trim(sPath)
    If sPath = "" Then
        m_sPath = ""
        m_bFileExists = False
        m_bReadOnly = False
        Exit Property
    End If
    On Error Resume Next
    FF = FreeFile
    Open sPath For Input As #FF
    If Err.Number <> 0 Then
        Err.Clear
        m_sPath = ""
        m_bFileExists = False
        m_bReadOnly = False
        Exit Property
    End If
    Close #FF
    m_sPath = sPath
    m_bFileExists = True
    Open sPath For Append As #FF
    If Err.Number <> 0 Then
        Err.Clear
        m_bReadOnly = True
    Else
        Close #FF
        m_bReadOnly = False
    End If
    On Error GoTo 0
    Load
End Property

Property Get Genre() As enGenres
Attribute Genre.VB_Description = "Sets / returns genre."
    Genre = CLng(m_iGenre)
End Property

Property Let Genre(lGenre As enGenres)
    m_iGenre = CIntGenre Aei